<template>
    <div class="container border-radius-20 appointments">
        <div class="row custom-row">
            <!-- Title + Create Button -->
            <div class="col-md-10">
                <h4>Appointments</h4>
            </div>

            <div class="col-md-2 col-12 text-right">
                <q-btn
                    class="border-radius-10 font-14 create-btn card-item-btn"
                    no-caps
                    @click="openCreateAppointmentForm()"
                >
                    Create Appointment
                </q-btn>
            </div>

            <!-- Appointment Table -->
            <div class="col-12 scroll">
                <vue-data-table
                    :headers="clientHeaders"
                    :data="prepareTable(appointments)"
                    :left-align="clientLeftAlign"
                    :update-status="updateStatus"
                />
                <vue-data-pagination
                    v-if="pagination.total > 20"
                    :data="pagination"
                    :selectPagePressed="selectPagePressed"
                ></vue-data-pagination>
            </div>

            <!-- Create Appointment Form -->
            <q-dialog v-model="state.appointmentDialog" persistent>
                <appointment-dialog />
            </q-dialog>
        </div>
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable @typescript-eslint/no-implicit-any-catch */

import { defineComponent, reactive, ref, onMounted, computed } from 'vue';
import VueDataTable from 'src/components/datatable/VueDataTable.vue';
import VueDataPagination from 'src/components/datatable/VueDataPagination.vue';
import { useStore } from 'src/store';
import { useI18n } from 'vue-i18n';
import { AppointmentListResponseResult } from '../../services/responses/appointment/AppointmentListReponse';
import { AppointmentStatus } from 'src/services/enums/AppointmentStatus';
import { orderBy } from 'lodash';
import { mapGetters } from 'vuex';
import { useQuasar } from 'quasar';
import AppointmentDialog from 'src/components/modals/AppointmentDialog.vue';

export default defineComponent({
    name: 'Appointment',
    components: {
        VueDataTable,
        VueDataPagination,
        AppointmentDialog
    },
    props: {
        requestConversationButton: {
            type: Function,
            default: () => ''
        },
        transferConversationButton: {
            type: Function,
            default: () => ''
        },
        ticketIDLink: {
            type: Function,
            default: () => ''
        }
    },
    computed: {
        ...mapGetters({
            appointments: 'appointment/appointments'
        })
    },
    setup() {
        const store = useStore();
        const { t } = useI18n();
        const $q = useQuasar();
        const lang = store.state.user.user?.locale;

        const pagination = computed(() => {
            return store.state.appointment.appointmentsPagination;
        });

        let state = reactive({
            appointmentDialog: ref(false),
            currentPage: 1,
            selectedClient: {} as any,
            reset: ref(false),
            start: '' as any,
            endTime: '' as any,
            user: '' as any,
            serviceTypes: ref([]),
            clientOptions: ref([]),
            serviceTypesOptions: ref([]),
            remark: '' as any
        });

        const clientHeaders = [
            t('tables.selectedDate', {}, { locale: lang }),
            t('tables.startTime', {}, { locale: lang }),
            t('tables.endTime', {}, { locale: lang }),
            t('tables.remark', {}, { locale: lang }),
            t('tables.serviceType', {}, { locale: lang }),
            t('tables.agent', {}, { locale: lang }),
            t('tables.user', {}, { locale: lang }),
            t('tables.status', {}, { locale: lang })
        ];
        const clientLeftAlign = ['client', 'serviceTypes'];

        // Method
        const prepareTable = (result: any) => {
            const formatResult = orderBy(
                result.appointments,
                ['createdAt'],
                ['desc']
            );

            const appointment: any = [];
            formatResult.forEach((result: any) => {
                let conversationStatus = '';
                switch (result.status) {
                    case AppointmentStatus.REJECTED:
                        conversationStatus = 'Rejected';
                        break;
                    case AppointmentStatus.ACCEPTED:
                        conversationStatus = 'Accepted';
                        break;
                    case AppointmentStatus.PENDING:
                        conversationStatus = 'Pending';
                        break;
                    case AppointmentStatus.CANCELLED:
                        conversationStatus = 'Cancelled';
                        break;
                }

                appointment.push({
                    selectedDate: result.selectedDate,
                    startTime: result.startTime,
                    endTime: result.endTime,
                    remark: result.remark == '' ? '-' : result.remark,
                    serviceTypes: result.serviceTypes,
                    agent: '-',
                    user: result.user.name,
                    status: {
                        text: conversationStatus,
                        appointmentID: result.id
                    }
                });
            });
            return appointment;
        };

        const getAppointments = async () => {
            let obj = {
                page: state.currentPage
            };

            const result: AppointmentListResponseResult = await store.dispatch(
                'appointment/getAppointments',
                obj
            );

            prepareTable(result);
            store.dispatch('appointment/setAppointments', result);
            store.dispatch(
                'appointment/setAppointmentPagination',
                result.pagination
            );
        };

        const openCreateAppointmentForm = () => {
            state.appointmentDialog = true;
        };

        const getUserList = async () => {
            const result: any = await store.dispatch('business/getCustomer');

            const options: any = [];

            if (result) {
                result.customers.forEach((element: any) => {
                    let results = {
                        id: element.id,
                        name: element.name
                    };
                    options.push(results);
                });

                state.clientOptions = options;
            }
        };

        const filterUser = (val: any, update: any) => {
            update(async () => {
                if (val != '') {
                    let query = {
                        page: state.currentPage,
                        keyword: val,
                        limit: 20
                    };
                    const result: any = await store.dispatch(
                        'business/getCustomer',
                        query
                    );

                    const options: any = [];

                    if (result) {
                        result.customers.forEach((element: any) => {
                            let results = {
                                id: element.id,
                                name: element.name
                            };
                            options.push(results);
                        });

                        state.clientOptions = options;
                    }
                } else {
                    getUserList();
                }
            });
        };

        const filterServiceTypes = async (val?: any) => {
            let query = {
                businessId: store.state.business.businessID,
                page: state.currentPage,
                keyword: val,
                limit: 20
            };

            const result: any = await store.dispatch(
                'service/getServiceTypeList',
                query
            );

            const options: any = [];

            let service = {
                id: '' as string,
                name: '' as string,
                childName: '' as string
            };

            // Will get parent id, if don't have child
            const data: any = result.result;
            if (data) {
                data.serviceTypes.forEach((element: any) => {
                    if (element.parentId == null) {
                        service = {
                            id: element.id,
                            name: element.name,
                            childName: ''
                        };
                        options.push(service);
                    }
                    data.serviceTypes.forEach((element2: any) => {
                        if (element2.parentId == element.id) {
                            service = {
                                id: element2.id,
                                name: element.name,
                                childName: element2.name
                            };
                            options.push(service);
                        }
                    });
                });

                state.serviceTypesOptions = options;
            }
        };

        const createAppointment = async () => {
            var datetime = state.start.split(' ');

            // Date Validation End time cannot be earlier then start time
            // const validate = moment(datetime[0] + datetime[1]).isAfter(
            //     moment(datetime[0] + state.endTime)
            // );

            // console.log(moment(datetime[0] + state.endTime));
            // console.log(moment(datetime[0] + datetime[1]));
            // console.log(validate);
            // state.appointmentDialog = true;
            // $q.dialog({
            //     component: AlertCustomDialog,
            //     componentProps: {
            //         title: t('alerts.endTimeIsEarlier'),
            //         message: '',
            //         actions: false
            //     }
            // });

            const body = {
                userId: state.user.id,
                selectedDate: datetime[0],
                startTime: datetime[1],
                endTime: state.endTime,
                remark: state.remark,
                serviceTypeIds: state.serviceTypes
            };

            await store.dispatch('appointment/createAppointment', body);

            clearField();
        };

        const clearField = () => {
            state.start = '';
            state.endTime = '';
            state.user = '';
            state.serviceTypes = [];
            state.clientOptions = [];
        };

        const selectPagePressed = (page: number) => {
            state.currentPage = page;
            getAppointments();
        };

        const updateStatus = (appointmentID: string) => {
            $q.dialog({
                title: 'Update Status',
                options: {
                    type: 'radio',
                    model: AppointmentStatus.ACCEPTED.toString(),
                    items: [
                        {
                            label: 'Accepted',
                            value: AppointmentStatus.ACCEPTED.toString()
                        },
                        {
                            label: 'Rejected',
                            value: AppointmentStatus.REJECTED.toString()
                        },
                        {
                            label: 'Cancelled',
                            value: AppointmentStatus.CANCELLED.toString()
                        }
                    ]
                },
                cancel: true,
                persistent: true
            }).onOk(async (data: any) => {
                const body = {
                    status: data,
                    appointmentId: appointmentID
                };
                await store.dispatch(
                    'appointment/updateAppointmentStatus',
                    body
                );
            });
        };

        // Mounted
        onMounted(getAppointments);
        onMounted(filterServiceTypes);
        onMounted(getUserList);

        // Watch
        store.watch(
            (state) => (state.business.businessID, state.branch.branch.id),
            () => {
                getAppointments();
            }
        );

        return {
            state,
            tab: ref('add'),
            clientHeaders,
            clientLeftAlign,
            openCreateAppointmentForm,
            filterUser,
            filterServiceTypes,
            createAppointment,
            pagination,
            selectPagePressed,
            prepareTable,
            updateStatus
        };
    }
});
</script>
